library IEEE;
USE IEEE.std_logic_1164.all;

entity ZSB is
port( BR, BL: in std_logic;	 
D_ALB_Q: in std_logic_vector (3 downto 0);	
SB0, SB3: inout std_logic;	 
Q_ZSB: out std_logic_vector(3 downto 0) );	 
end;

architecture move_reg of ZSB is
begin
process(BL, BR) begin
if (BL = '0' and BR = '0') then	 
Q_ZSB <= D_ALB_Q;
SB3 <= '0';
SB0 <= '0';
elsif (BL = '0' and BR = '1') then	 
Q_ZSB(3) <= SB3;	
for i in 2 downto 0 loop
Q_ZSB(i) <= D_ALB_Q(i+1);
end loop;
SB0 <= D_ALB_Q(0);	
elsif (BL = '1' and BR = '0') then	 
SB3 <= D_ALB_Q(3);
for i in 3 downto 1 loop
Q_ZSB(i) <= D_ALB_Q(i-1);
end loop;	
Q_ZSB(0) <= SB0;
end if;
end process;
end;